﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Reflection;
using System.Collections;

namespace EmbeddedResource.Library
{
    public class StatesCollection : System.Collections.Generic.List<State>
    {
        private StatesCollection()
        {

        }

        private static StatesCollection _southernStates = null;
        public static StatesCollection SouthernStates
        {
            get
            {
                if (_southernStates == null)
                {
                    StatesCollection states = new StatesCollection();
                    try
                    {
                        System.Reflection.Assembly asm = Assembly.GetExecutingAssembly();
                        System.IO.Stream xmlStream = asm.GetManifestResourceStream("EmbeddedResource.Library.Data.SouthernStates.xml");
                        XmlDocument xmlDoc = new XmlDocument();
                        xmlDoc.Load(xmlStream);
                        XmlNodeList nodes = xmlDoc.SelectNodes("/States/State");
                        StatesCollection coll = new StatesCollection();
                        foreach (XmlNode node in nodes)
                        {
                            State state = new State();
                            state.Abbreviation = node["Abbreviation"].InnerText;
                            state.Name = node["Name"].InnerText;
                            coll.Add(state);
                        }
                        return coll;
                    }
                    catch (Exception ex)
                    {
                        throw new Exception(ex.Message);
                    }
                }
                else
                {
                    return _southernStates;
                }
            }
        }
    }
}
