﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EmbeddedResource.Library;

namespace EmbeddedResourceExample
{
    class Program
    {
        static void Main(string[] args)
        {
            foreach (State state in StatesCollection.SouthernStates)
            {
                Console.WriteLine("Name: " + state.Name + " | Abbr: " + state.Abbreviation);
            }

            Console.WriteLine("-------- LINQ --------");

            var q = from state in StatesCollection.SouthernStates
                    orderby state.Name ascending
                    select state.Abbreviation;

            List<string> sortedStates = q.ToList<string>();

            for (int i = 0; i < sortedStates.Count; i++)
            {
                Console.WriteLine(sortedStates[i]);
            }
            
            Console.ReadLine();
        }
    }
}
